#ifndef SHMEMLOCKEDQUEUE_H
#define SHMEMLOCKEDQUEUE_H

#include "nt_ipvishm_global_cpp.h"
//#include "nt_ipvishm_message_queue.h"

// With the environment variable MPICH_USE_POLLING undefined the remove functions wait on a kernel event handle
// With MPICH_USE_POLLING defined the remove functions poll a variable in shared memory

#define SHMEM_Q_AVAIL_FOR_WRITE		0
#define SHMEM_Q_BEING_WRITTEN		1
#define SHMEM_Q_AVAIL_FOR_READ		2
#define SHMEM_Q_SHP_AVAIL_FOR_READ	3
#define SHMEM_Q_BEING_READ			4
#define SHMEM_Q_READ				5

class ShmemLockedQueue
{
public:
	struct ShmemLockedQueueHeader
	{
		int tag, from, state;
		unsigned int length;
		unsigned long next_offset;
	};

	ShmemLockedQueue();
	~ShmemLockedQueue();

	bool Init(char *name, unsigned long size);
	bool Insert(unsigned char *buffer, unsigned int length, int tag, int from);
	bool InsertSHP(unsigned char *buffer, unsigned int length, int tag, int from, HANDLE hRemoteMutex, HANDLE hRemoteEvent);
	bool RemoveNext(unsigned char *buffer, unsigned int *length, int *tag, int *from);
	bool RemoveNextInsert(MessageQueue *pMsgQueue);

private:
	HANDLE m_hMapping;
	LONG *m_hQMutex, *m_hQEmptyEvent;
	HANDLE m_hMsgAvailableEvent;
	LONG *m_plMsgAvailableTrigger;
	bool m_bUseEvent;
	LPVOID m_pBottom, m_pBase, m_pEnd;
	unsigned long m_dwSize, m_dwMaxMsgSize;
};

#endif
